#include <Arduino.h>
#include "config.h"
#include "sdcard.h"
#include "ArduinoJson.h"
#include "blacksasi.h"
extern SdFs SD;
extern FsFile LOG_FILE;
extern byte SCSI_INFO_BUF[SCSI_INFO_BUF_SIZE];
extern SCSI_DEVICE scsi_device_list[NUM_SCSIID][NUM_SCSILUN]; // Maximum number
// If config file exists, read the first three lines and copy the contents.
// File must be well formed or you will get junk in the SCSI Vendor fields.
uint32 readSCSIDeviceConfig(SCSI_DEVICE *dev) {

  SCSI_INQUIRY_DATA *iq = dev->inquiry_block;

  StaticJsonDocument<2048> config;
  delay(1000);
  FsFile config_file = SD.open("blacksasi.json", O_RDONLY);
  char vendor[9];
  char product[17];
  char version[5];
  memset(vendor, 0, sizeof(vendor));

  if (!config_file.isOpen()) {
    return 1;
  }
  
  DeserializationError error = deserializeJson(config, config_file);
  if (error){
    Serial.println(F("Failed to read file"));
    return 1;
  }
  String vendorx = config["vendor"];
  uint16 len = (vendorx.length()>8?8:vendorx.length());
  memset(&iq->vendor, 0, sizeof(vendor));
  vendorx.toCharArray(vendor,len);
  memcpy(&iq->vendor, vendor, len);

  String productx = config["product"];
  len = (productx .length()>16?16:productx .length());
  memset(&iq->product, 0, sizeof(product));
  productx.toCharArray(product,len);
  memcpy(&iq->product, product, len);

  String configx = config["version"];
  len = (configx.length()>4?4:configx.length());
  memset(&iq->revision, 0, sizeof(version));
  configx.toCharArray(version,len);
  memcpy(&iq->revision, version, len);

  
  dev->m_quirks=S2S_CFG_QUIRKS_NONE;
  
  if (config["controller"]){
    String controller = config["controller"];
    controller.toUpperCase();
    if (controller=="XEBEC" )
      dev->m_quirks=S2S_CFG_QUIRKS_XEBEC;
  }
  return 0;

}
uint32 readHWVersion(){
    return((digitalRead(BOARD_REV_PIN0 ) == LOW) ) | ((digitalRead(BOARD_REV_PIN1 ) == LOW) ) << 1 | ((digitalRead(BOARD_REV_PIN2) == LOW) ) << 2;
  
}